<?php
/*
Classe HomESpliT
Version : 1.1
Date de cration : 22 05 2006
Date de version : 21 11 2007
Description : Scinde un texte long pour affichage page  page
*/
class hest{

	//variables
	private $message;//Messages d'erreur pendant l'excution
	private $long;//Longueur de base des fragments
	private $stringOrig;//chaine d'origine
	private $page;//texte fragment en pages
	private $string;//chaine  retourner au navigateur (=contenu d'une page)
	private $toAddFrag;//chaine d'ajout au fragment en cours (fermetures de tags)
	private $toAddSuite;//chaine d'ajout  la suite du fragment en cours (ouvertures de tags ferms par la classe)
	private $tempTitres;//variable de stockage temporaire pour les titres
	private $varGetName;//nom de la variable permettant d'afficher une page (GET par l'url ou POST par le formulaire)
	private $varGet;//numro de la page  afficher
	private $indexChap;//rfrence des chapitres par pages

	function __construct($string,$long=1500,$varGet="p"){
		//constructeur de classe
		$this->message=array();
		$this->long=$long;
		if(!is_array($string)) $string=array($string);//une seule page
		$this->stringOrig=$string;
		$this->string=$this->splitIt();
		$this->varGetName=$varGet;
		$this->varGet=(isset($_POST[$varGet])&&is_numeric($_POST[$varGet]))?$_POST[$varGet]-1:((isset($_GET[$varGet]))?$_GET[$varGet]:0);
	}

	private function splitIt(){
		//Fragmentation du texte $this->string en morceaux de longueur $this->long
		$chapitre=array();
		foreach($this->stringOrig as $part){
			$chapitre=array_merge($chapitre,explode("<break>", $part));
		}
		$page=array();
		foreach($chapitre as $chap){
			$page=array_merge($page,$this->frag($chap));
		}
		return $page;
	}

	private function frag($entre,$sort=""){
		//fragmente un chapitre et renvoie le tableau $sort contenant ses pages de faon rcursive
		if($sort=="") $sort=array();
		$preFrag=substr($entre,0,$this->long);//extrait un fragment de la longueur dsire
		$posFin=($this->long<strlen($entre))?strrpos($preFrag," ")+1:strlen($entre);//dtermine la position du dernier espace
		if($posFin!==false){
			//un espace a t trouv
			$this->toAddFrag=array();
			$this->toAddSuite=array();
			$fragPropose=substr($preFrag,0,$posFin);
			$reste=substr($entre,$posFin);
			preg_match_all("/\/+.{1,}>/m",$fragPropose,$closed);
			if(substr_count($fragPropose,"<")>sizeof($closed[0])){
				$correct=$this->htmlCorrect($reste,$fragPropose);
				$fragPropose=$correct['frag'];
				$reste=$correct['chaine'];
			}
			$sort[]=$fragPropose;
			if(strlen($reste)<=$this->long){
				//si le reste n'est pas assez long
				if($reste!="") $sort[]=$reste;

			}
			else{
				//reste suffisant -> appel rcursif
				return $this->frag($reste,$sort);
			}
			return $sort;
		}
		else{
			//la chaine n'est pas fragmentable
			return $entre;
		}
	}

	private function htmlCorrect($suite,$frag,$pos=0){
		//corrige un fragment $frag dont les tags ne sont pas complets
		$pos0_tag=strpos($frag,"<",$pos);
		if($pos0_tag!==false){
			$pos1_tag=strpos($frag,">",$pos0_tag);
			if($pos1_tag!==false){
				$tagComplet=substr($frag,$pos0_tag,$pos1_tag-$pos0_tag+1);//extraction du tag complet
				if(!strstr($tagComplet,"</")&&!strstr($tagComplet," />")){
					//Si ce n'est pas un tag de fermeture ou un tag unique ferm
					$posFinIdTag=strpos($tagComplet," ");//repre la fin du nom
					if($posFinIdTag!==false) $idTag=substr($tagComplet,1,$posFinIdTag-1);
					else $idTag=substr($tagComplet,1,strlen($tagComplet)-2);
					$posFermeture=strpos($frag,"</".$idTag.">",$pos1_tag+1);//dtermine la position du tag de fermeture
					if($posFermeture!==false){
						//fermeture trouve dans l'extrait
						$posSuivante=$pos1_tag;
					}
					else{
						//le tag n'est pas ferm
						$tagsExclus=array("h1","h2","h3","h4","h5","h6","a","img","li");//liste des tags ne supportant pas la scission
						if(!in_array($idTag,$tagsExclus)&&$idTag!="p"){
							//si le tag peut tre scind
							$this->toAddFrag[]="</".$idTag.">";//ajout du tag de fin  l'extrait
							$this->toAddSuite[]=$tagComplet;
							$posSuivante=$pos1_tag;//dtermine la longueur de l'extrait rduit  la partie non-analyse
						}
						else{
							//si le tag ne peut tre scind
							$posFermeture=strpos($suite,"</".$idTag.">")+strlen("</".$idTag.">");//dtermine la position de fin du tag de fermeture dans la suite
							$frag.=substr($suite,0,$posFermeture);
							$suite=substr_replace($suite,"",0,$posFermeture);
							$posSuivante=strlen($frag)-1;//dtermine la longueur de l'extrait rduit  la partie non-analyse
						}
					}
				}
				else{
					//le tag n'a pas  tre ferm
					$posSuivante=$pos1_tag;
				}
			}
			else{
				//ce tag ouvrant n'est pas ferm (ex : <h2 class=)
				$suppr=substr($frag,$pos0_tag);
				$frag=substr_replace($frag,"",$pos0_tag,strlen($suppr));
				$suite=$suppr.$suite;
				$posSuivante=strlen($frag)-1;//dtermine la longueur de l'extrait rduit  la partie non-analyse
			}
			return $this->htmlCorrect($suite,$frag,$posSuivante);//recursivit
		}
		reset($this->toAddSuite);
		array_reverse($this->toAddSuite);
		$verifAdd=(strip_tags(implode("",$this->toAddSuite).$suite)!="")?implode("",$this->toAddSuite):"";
		return  array("frag"=>$frag.implode("",$this->toAddFrag),"chaine"=>$verifAdd.$suite);
	}

	public function backMem(){
		$ret=array();
		$cpt=0;
		if(sizeof($this->message)<1){
			foreach($this->string as $elem){
				$ret[]=$elem."<div class=\"NavigPages\">".$this->displayNav($cpt++)."</div>";
			}
		}
		else{
			$ret[]=implode("<br />",$this->string);
		}
		return $ret;
	}

	public function display($addNav=false){
		//fonction d'affichage du rsultat
		if(sizeof($this->message)<1){
			echo $this->string[$this->varGet];
			if($addNav===true) echo "<div class=\"NavigPages\">".$this->displayNav()."</div>";
		}
		else{
			echo implode("<br />",$this->string);
		}
	}

	public function displayNav($num=null){
		//affichage de la navigation
		if($num==null) $num=$this->varGet;
		$numPages=sizeof($this->string);
		$maxP=$numPages-1;
		$pPrec=$pSuiv="";
		$lig=(strstr($_SERVER['REQUEST_URI'],"?"))?"&":"?";
		$url=(isset($_GET['chM']))?str_replace("&chM=".$_GET['chM'],"",$_SERVER['REQUEST_URI']):$_SERVER['REQUEST_URI'];
		if($num>0){
			if(isset($_GET[$this->varGetName])){
				$urlPre=preg_replace("/".$this->varGetName."=\d*/",$this->varGetName."=".($num-1),$url);
			}
			else $urlPre=$url.$lig.$this->varGetName."=".($num-1);
			$pPrec="[<a href=\"".str_replace("&","&amp;",$urlPre)."\" class=\"navPages\" title=\"Page prcdente\">&nbsp;&lt;&nbsp;</a>]";
		}
		if($num<$maxP){
			if(isset($_GET[$this->varGetName])){
				$urlSuiv=preg_replace("/".$this->varGetName."=\d*/",$this->varGetName."=".($num+1),$url);
			}
			else $urlSuiv=$url.$lig.$this->varGetName."=".($num+1);
			$pSuiv="[<a href=\"".str_replace("&","&amp;",$urlSuiv)."\" class=\"navPages\" title=\"Page suivante\">&nbsp;&gt;&nbsp;</a>]";
		}
		return $pPrec."&nbsp;Page ".($num+1)."/".$numPages."&nbsp;".$pSuiv;
	}
	
	public function displayForm(){
		//affichage du formulaire d'accs  une page
		return "<form method=\"post\" action=\"".$SERVER['REQUEST_URI']."\"><div><label for=\"".$this->varGetName."\">Aller  la page <input type=\"text\" name=\"".$this->varGetName."\" id=\"".$this->varGetName."\" size=\"4\" value=\"\" /></label><input type=\"submit\" value=\"Go\" /></div></form>";
	}

	public function doIndex(){
		$ret="";
		$tempInd=0;//compteur index chapitres
		$this->tempTitres=array();//remise  z du stockage pour la premire boucle
		while(list($ind,$page)=each($this->string)){//pour chaque page
			for($i=0;$i<4;$i++){//pour les titres de niveau 1  4
				$this->findHead($page,$i,$ind);//effectuer la recherche -> stockage dans $tempTitres
			}
			if(!isset($this->tempTitres[$ind])){
				array_push($this->indexChap[$tempInd],$ind);
			}
			else{
				for($i=0; $i<sizeof($this->tempTitres[$ind]); $i++){
					$tempInd++;
					$this->indexChap[$tempInd]=array($ind);
				}
			}
		}
		$tempInd=0;
		while(list($indPage,$titreCont)=each($this->tempTitres)){
			foreach($titreCont as $titre){
				$lig=(strstr($_SERVER['REQUEST_URI'],"?"))?"&":"?";
				$newUrl=(isset($_GET[$this->varGetName]))?preg_replace("/".$this->varGetName."=\d*/",$this->varGetName."=".$indPage,$_SERVER['REQUEST_URI']):$_SERVER['REQUEST_URI'].$lig.$this->varGetName."=".$indPage;
				$newUrl=str_replace("&","&amp;",$newUrl);
				$ret.="<li class=\"t".$titre['niveau']."\"><a href=\"".$newUrl."\"".((in_array($this->varGet,$this->indexChap[$tempInd+1]))?" class=\"on\"":"").">".$titre['titre']."</a></li>\n";
				$tempInd++;
			}
		}
		if($ret!="") return "<div class=\"indexDoc\"><ol><li><b>Index</b></li>\n".$ret."</ol></div>\n";
		else return "";
	}

	private function findHead($string,$tag,$page,$start=0){
		$pos1=strpos($string,"<h$tag>",$start);
		if($pos1!==false){
			if(!isset($this->tempTitres[$page])) $this->tempTitres[$page]=array();
			$pos2=strpos($string,"</h$tag>",$pos1+4);
			$longueurOrigine=($pos2-($pos1+4));
			$titre=substr($string,$pos1+4,$longueurOrigine);
			$this->tempTitres[$page][$pos1]=array("titre"=>strip_tags($titre,"b,strong,i,em,u,span" ),"niveau"=>$tag);
			$posSuiv=$pos2+5;
			$this->findHead($string,$tag,$page,$posSuiv);//appel rcursif
		}
	}
}
?>